
import java.awt.*;
import java.awt.event.*;
import java.applet.*;

abstract public class BesselGUI extends PhysicsApplet{

    PlotDisplay theCurves;
       // button codes
    static final int AddCurveCode = 1;
    static final int ResetCode = 2;
    static final int ScrollbarCode = 3;
       // scrollbar
    PhysicsScrollbar kBar;
    BoldLabel kLabel;
    double k;

    BesselGUI(){
       super("Bessel Functions", 400, 300, 1, 40);
    }
          
    void resetAll(){
       theCurves.refresh();
    }

    void buildPicture(){
        theCurves = new PlotDisplay(0.0,1.5, -0.5, 1.1, 0.1, 0.1);
   	Picture.add(theCurves,"Center");
    }

    void refreshPicture(){
        theCurves.refresh();
    }

    void plot(){
        theCurves.horizontalAxis(0.0);
        theCurves.setColor(Color.magenta);
        theCurves.verticalAxis(1.0);
        theCurves.switchColor();
    }

    void buildControls(){
        Controls.setLayout(new GridLayout(0,3, 10, 10));
        CommandButton B1 = new CommandButton("Add Curve", AddCurveCode);
        Controls.add(B1);
        CommandButton B2 = new CommandButton("Reset", ResetCode);
        Controls.add(B2);
        Label B3 = new Label(" ");
        Controls.add(B3);
        BoldLabel B5 = new BoldLabel("       k: ");
        Controls.add(B5);
        kBar = new PhysicsScrollbar(2.0, 2.0, 25.0,ScrollbarCode);
        Controls.add(kBar);
        kLabel = new BoldLabel("    2.0");
        k = 2.0;
        Controls.add(kLabel);
    }

    void plotBessel(){
        plotStream PS = new plotStream();
	for (double x = 0.0;  x <= 1.5; x += 0.01){
	  PS.add(x,Bessel(k*x));
	}
        theCurves.plotCurve(PS);
        theCurves.switchColor();
    }

    void doAction(int Code){
        switch(Code){
	  case AddCurveCode:
	      plotBessel();
              break;
          case ResetCode:
              resetAll();
              break;
	  case ScrollbarCode:
              k =  kBar.getReading();
              kLabel.setText("      "+k);
              break;
	  default:
              break;
        }
    }

    void resetArrays(){ }
    Color findColor(double A, int S){ return Color.black; }
    void writeFieldValue(double Val, int mode){}
    void writeVectorValue(double Vx, double Vy, int mode){}
    void setArrays(int i, int j, int mode){}
    void solve(){}

    abstract double Bessel(double z);
}


