
import java.awt.*;
import java.awt.event.*;
import java.applet.Applet;

public class Dielectric extends DielectricGUI {

  double criterion = 1.0e-2;

  void solve(){
    double maxdiff = 1.0;
    int iteration = 0;
    double e1 = 1.0, e2 = 1.0, e3 = 1.0, e4 = 1.0;
    while ( maxdiff > criterion){
      for (int n = 1; n <= 20; n++){
        maxdiff = 0.0;
        for (int i = 1; i < Nx; i++){
          for (int j =1 ; j < Ny; j++){
            if (normal(i,j) == false) continue;
            double oldphi = phi[i][j];
	        /*  find the values of epsilon at the grid points */
            e1 = getepsilon(i,j);
            e2 = getepsilon(i+1,j);
            e3 = getepsilon(i,j+1);
            e4 = getepsilon(i+1,j+1);
                /* change this to the correct algorithm  */
	    double newphi = 33.0;
            phi[i][j] = newphi;
	        /* compute the criterion for stopping */
            double delta = Math.abs(newphi-oldphi);
            if (delta > maxdiff) maxdiff = delta;
          }
        }
        iteration++;
    } 
    refreshPicture();
    Legend.write("max. diff : "+maxdiff+ "      "+iteration);
    if (timetostop) break;
    }
  }

  double Energy(){
     return 0.0;
  }
}

