
import java.awt.*;
import java.awt.event.*;
import java.applet.Applet;

public class myDielectric extends DielectricGUI {

  double criterion = 1.0e-2;

  void solve(){
    double maxdiff = 1.0;
    int iteration = 0;
    double e1 = 1.0, e2 = 1.0, e3 = 1.0, e4 = 1.0;
    while ( maxdiff > criterion){
      for (int n = 1; n <= 20; n++){
        maxdiff = 0.0;
        for (int i = 1; i < Nx; i++){
          for (int j =1 ; j < Ny; j++){
            if (normal(i,j) == false) continue;
            double oldphi = phi[i][j];
	        /*  find the values of epsilon at the grid points */
            e1 = getepsilon(i,j);
            e2 = getepsilon(i+1,j);
            e3 = getepsilon(i,j+1);
            e4 = getepsilon(i+1,j+1);
	        /*  update phi  */
	    double newphi = (e1 * phi[i-1][j] + e1 * phi[i][j-1]
               + e2 * phi[i+1][j] + e3 * phi[i][j+1])/(2.0 * e1 + e2 + e3);
            phi[i][j] = newphi;
	        /* compute the criterion for stopping */
            double delta = Math.abs(newphi-oldphi);
            if (delta > maxdiff) maxdiff = delta;
          }
        }
        iteration++;
    } 
    refreshPicture();
    Legend.write("max. diff : "+maxdiff+ "      "+iteration);
    if (timetostop) break;
    }
  }

  double Energy(){
   double a = 0.001;    /*  a = 1 mm ; total size = 10 cm for Nx = 100 */
   double d = 0.1;      /*   length in z = 10 cm  */ 
   double epsilon0 = 8.85e-12;
   double theenergy = 0.0;
   for (int i = 1; i <= Nx; i++){
     for (int j =1 ; j <= Ny; j++){
       double eps = getepsilon(i,j);
       double Ex = (phi[i][j] - phi[i-1][j])/a;
       double Ey = (phi[i][j] - phi[i][j-1])/a;
       theenergy +=  a*a*d * eps * (epsilon0/2.0) * ( Ex*Ex + Ey*Ey);
     }
   }
   return theenergy;     /*  in Joules   */
  }

}

