
import java.awt.*;
import java.awt.event.*;
import java.applet.Applet;

public class Diffraction extends DiffractionGUI {

  int Nres = 150;
  double [] allsines;

  public Diffraction(){
      /* example of pre-computation of an array: */ 
      double dNres = Nres;
      allsines = new double[2*Nres];
      for (int j = 0; j< 2*Nres ; j++){
	allsines[j] = Math.sin(2.0 * Math.PI * j/dNres);
      }
  }

  void solve(){
    resetArrays();   /* zeros the array phi */
    for (int m = 1; m < Nx; m++){
      for (int n =1; n < Ny ; n++){
	double realamp = 0.0;
        double imamp = 0.0;
   /* so that, effectively, (0,0) appear in the center of the square */
        int mm = m - (Nx/2);
        int nn = n - (Nx/2);
        for (int i = 1; i < Nx; i++){
          for (int j =1; j < Ny ; j++){
	    if (State[i][j] == blackState) continue;
                /* add contributions from white squares ; 
	          put something more sensible here:  */
	    realamp += 0.0;
	    imamp +=   0.0;
          }
        }
        phi[m][n] = (realamp*realamp + imamp*imamp);
      }
    }
    Legend.write(" ");
    refreshPicture();
  }

}

