
import java.awt.*;
import java.awt.event.*;
import java.applet.Applet;

public class myDiffraction extends myDiffractionGUI {

  int Nres = 150;
  double [] thecoses;
  double [] thesins;
  double [] theslit;
    /* I assume Nx = Ny  */

  public myDiffraction(){
      double dNres = Nres;
      thecoses = new double[2*Nres];
      thesins = new double[2*Nres];
      theslit = new double[Nx+1];
      for (int j = 0; j< 2*Nres ; j++){
	thecoses[j] = Math.cos(2.0 * Math.PI * j/dNres);
	thesins[j] = Math.sin(2.0 * Math.PI * j/dNres);
      }
      for (int j = 0; j <= Nx; j++){
          int k = j - (Nx/2);
          double ts = 1.0;
          if( (k % Nres) != 0) 
              ts = Math.sin(Math.PI * k/dNres)/ (Math.PI * k/dNres);
          theslit[j] = ts *ts;
      }
  }

  void solve(){
    resetArrays();   /* zeros the array phi */
    for (int m = 1; m < Nx; m++){
      for (int n =1; n < Ny ; n++){
	double realamp = 0.0;
        double imamp = 0.0;
        int mm = m - (Nx/2);
        int nn = n - (Nx/2);
        for (int i = 1; i < Nx; i++){
          for (int j =1; j < Ny ; j++){
	    if (State[i][j] == blackState) continue;
            int p = (mm*i+nn*j)% Nres + Nres;
	    realamp += thecoses[p];
	    imamp += thesins[p];
          }
        }
        phi[m][n] = (realamp*realamp + imamp*imamp) *theslit[m]*theslit[n];
      }
    }
    Legend.write(" ");
    refreshPicture();
  }

}

