
public class myFourierTransform{

    /*  note that this intentionally does not implement the 
	       Fast Fourier Transform algorithm    */

    int Nx, N2;
    double Nd;
    double[] f, fcos, fsin;
    double[] coss, sins;

    myFourierTransform(int N){
        Nx = N;
        N2 = Nx/2;
        Nd = Nx;
	f = new double[Nx];
        fcos = new double[N2+1];
        fsin = new double[N2+1];
        coss = new double[Nx];
        sins = new double[Nx];
        for (int k = 0; k < Nx; k++){
	    coss[k] = Math.cos(2.0 * Math.PI * k/Nd);
            sins[k] = Math.sin(2.0 * Math.PI * k/Nd);
        }
    }

    void Transform(){
	for (int i = 0; i <= N2 ; i++){
	    double Tc = 0.0;
	    double Ts = 0.0;
            for (int j = 0; j < Nx ; j++){
                int k = (i*j) % Nx;
		Tc +=  f[j] * coss[k];
                Ts +=  f[j] * sins[k];
            }
            fcos[i] = Tc;
            fsin[i] = Ts;
	}
    }

    void InverseTransform(){
        int s = -1;
	for (int i = 0; i < Nx ; i++){
            s *= -1;
	    double T = fcos[0] +  s * fcos[N2];
            for (int j = 1; j < N2 ; j++){
                int k = (i*j) % Nx;
                T +=  fcos[j] * 2.0 * coss[k] + fsin[j] * 2.0 * sins[k];
            }
            f[i] = T/Nd;
	}
    }
}

