
import java.awt.*;
import java.awt.event.*;
import java.applet.Applet;

public class Laplace extends LaplaceGUI{

  double criterion = 1.0e-2;

  void solve(){
    double maxdiff = 1.0;
    int iteration = 0;
    while ( maxdiff > criterion){
      for (int n = 1; n <= 20; n++){
        maxdiff = 0.0;
        for (int i = 1; i < Nx; i++){
          for (int j =1 ; j < Ny; j++){
              /* check whether (i,j) is a cathode or ground point */
            if (normal(i,j) == false) continue;
              /* update the phi array  */
            double oldphi = phi[i][j];
              /*  put something more sensible here  : */
            double newphi = 33.0;
            phi[i][j] = newphi;
	    /*  compute the criterion for stopping */
            double delta = Math.abs(newphi-oldphi);
            if (delta > maxdiff) maxdiff = delta;
          }
        }
        iteration++;
      } 
      refreshPicture();
      Legend.write("max. diff : "+maxdiff+ "      "+iteration);
      if (timetostop) break;
    }
  }

  double Energy(){
     return 0.0;
  }
}
