
import java.awt.*;
import java.awt.event.*;
import java.applet.Applet;

public class myLaplace extends LaplaceGUI{

  double criterion = 1.0e-2;

  void solve(){
    double maxdiff = 1.0;
    int iteration = 0;
    while ( maxdiff > criterion){
      for (int n = 1; n <= 20; n++){
        maxdiff = 0.0;
        for (int i = 1; i < Nx; i++){
          for (int j =1 ; j < Ny; j++){
	      /* check whether (i,j) is a cathode or ground point */
            if (normal(i,j) == false) continue;  
              /* update the phi array  */
            double oldphi = phi[i][j];
            double newphi = 0.25 * (phi[i-1][j] + phi[i][j-1] 
                            + phi[i+1][j] + phi[i][j+1]);
            phi[i][j] = newphi;
	      /*  compute the criterion for stopping */
            double delta = Math.abs(newphi-oldphi);
            if (delta > maxdiff) maxdiff = delta;
          }
        }
        iteration++;
    } 
    refreshPicture();
    Legend.write("max. diff : "+maxdiff+ "      "+iteration);
    if (timetostop) break;
    }
  }

  double Energy(){
   double a = 0.001;    /*  a = 1 mm ; total size = 10 cm for Nx = 100 */
   double d = 0.1;      /*   length in z = 10 cm  */ 
   double epsilon0 = 8.85e-12;
   double theenergy = 0.0;
   for (int i = 1; i <= Nx; i++){
     for (int j =1 ; j <= Ny; j++){
       double Ex = (phi[i][j] - phi[i-1][j])/a;
       double Ey = (phi[i][j] - phi[i][j-1])/a;
       theenergy +=  a*a*d * (epsilon0/2.0) * ( Ex*Ex + Ey*Ey);
     }
   }
   return theenergy;     /*  in Joules   */
  }
}
