
import java.awt.*;
import java.awt.event.*;
import java.applet.Applet;

public class myMagnet extends MagnetGUI{

  double mu0 =  (1.0e-3) * 4.0 * Math.PI;    /*  units are gauss m/A  */
  double criterion = 1.0e-2;

  public myMagnet(){
    a = 1.0e-3;   /* grid spacing, in m  */
    Bscale = 5.0;   /*  scale, in gauss, for the display of B */
    Icell = 10.0;   /* current in A flowing out of /into one cell */
  }

  void solve(){
    double maxdiff = 1.0;
    int iteration = 0;
    double mu1, mu2, mu3, mu4, cellcurrent;
    while ( maxdiff > criterion){
      for (int n = 1; n <= 20; n++){
        maxdiff = 0.0;
        for (int i = 1; i < Nx; i++){
          for (int j =1 ; j < Ny; j++){
	      /*  find the values of mu at the grid points */
            mu1 = getmu(i,j);
            mu2 = getmu(i+1,j);
            mu3 = getmu(i,j+1);
            mu4 = getmu(i+1,j+1);
	       /*  find the current at the grid point */
            cellcurrent = getcurrent(i,j);
            double oldA = A[i][j];
	        /*  update A */
            double newA = (A[i-1][j]/mu1 + A[i][j-1]/mu1 
	      + A[i+1][j]/mu2 + A[i][j+1]/mu3)/(2.0/mu1 + 1.0/mu2 + 1.0/mu3);
            newA +=  mu0 * cellcurrent/(2.0/mu1 + 1.0/mu2 + 1.0/mu3);
            A[i][j] = newA;
	        /*  compute the criterion for stopping */
            double delta = Math.abs(newA-oldA);
            if (delta > maxdiff) maxdiff = delta;
          }
        }
        iteration++;
    } 
    refreshPicture();
    Legend.write("max. diff : "+maxdiff+ "      "+iteration);
    if (timetostop) break;
    }
  }
}
