
/*
    There are no .h files in java, so do not try to compile this code.

    This file provides the information about PhysicsApplet.java that one
      obtains from a C++ .h file, namely, the list of classes, the 
      data for each class, and type and arguments of the methods for
      each class.
*/

abstract public class PhysicsApplet extends Applet
                                              implements Runnable 

       /*   useful variables  */
  int Nx, Ny;
  int pixelsize;
  TitleBanner Title;
  Panel Picture;
  Panel Controls;
  int mouseMode;
  Thread solver;

  PhysicsApplet(String thetitle, int nx, int ny, int Pixelsize, 
                                                      int extraxsize);

       /*  associated abstract methods  */
  abstract void resetArrays();
  abstract void resetAll();
  abstract void buildPicture();
  abstract void refreshPicture();
  abstract void buildControls();
  abstract void doAction(int Code);

     //  Thread stuff

       /*   useful variables  */
  boolean timetostop; 
    /*    test (timetostop == true) as a condition to exit the thread  */
 
  public void pause(int delay);

       /*  associated abstract methods  */
  abstract void solve();

    /*          classes for creating a GUI:

   ---------    TitleBanner       ----------------------  */  

  class TitleBanner extends Component
    
    TitleBanner(String title, int fontsize);
    public void write(String S);

    /*  ---------    ArrayDisplay       ----------------------  */
  
  class ArrayDisplay extends Component 
                     implements MouseListener, MouseMotionListener 

       /*   useful variables  */
    Color[] DisplayColors;
    Color[] altDisplayColors;

    public ArrayDisplay(double[][]  AA, int[][] id,
                                        Color MaxColor, Color BaseColor);
    public void refresh();
 
       /*  associated abstract methods  */
    abstract Color findColor(double A, int S);
    abstract void writeFieldValue(double Val, int mode);
    abstract void setArrays(int i, int j, int mode);

    /*  ---------    VectorDisplay       ----------------------  */


  class VectorDisplay extends Component
                     implements MouseListener, MouseMotionListener 

      /* the grid square (i,j) has its uppper left-hand corner 
          at  (leftmargin + i*pixelsize, (Ny-j+1)*pixelsize)
          and its center at  
	(leftmargin + i*pixelsize + halfp, (Ny-j+1)*pixelsize + halfpix) */

     public VectorDisplay(double[][]  BBx, double[][] BBy, int[][] id,
           double BScale, Color ArrowColor, Color DotColor){
     public void refresh();
     public void resetscale(double Bsc);
 
       /*  associated abstract methods  */
    abstract void writeVectorValue(double Vx, double Vy, int mode);
    abstract void setArrays(int i, int j, int mode);

    /*  ---------    CurveDisplay       ----------------------  */

  class CurveDisplay extends Component 
                     implements MouseListener, MouseMotionListener 

     public CurveDisplay(int Height, int ZeroPosition, double [] F, 
                               double[] H, double Fscale, double Hscale, 
			         Color FColor, Color HColor, int MouseMode);

     public void resetfscale(double fsc);
     public void resethscale(double hsc);
     public void refresh();

    /*  ---------    PlotDisplay       ----------------------  */

   class PlotDisplay extends Component

    public PlotDisplay(double Xa, double Xb, double Ya, double Yb,
		       double Xtick, double Ytick);
    void refresh();

    void setTicks(double xtick, double ytick);
    void drawLine(double x1, double y1, double x2, double y2);
    void drawRect(double x1, double y1, double x2, double y2);
    void drawString(String str, double x, double y);

    void verticalAxis(double X);
    void verticalAxis();
    void horizontalAxis(double Y);
    void horizontalAxis();

    void plotPoint(double X, double Xerr, double Y, double Yerr);
    void plotLines(plotStream PS);
    void plotHistogram(plotStream PS);
    void plotCurve(plotStream PS);

    void setColor(Color C);
    void switchColor();

       /*  associated abstract methods  */
    abstract void plot();

    // plotStream class used by PlotDisplay  

  class plotStream

    plotStream();

    public int size();

    void add(double X, double Y);
    void add(double X, double Y, double Yerr);
    void add(double X, double Xerr, double Y, double Yerr);
    double x(int i);
    double y(int i);
    double xerr(int i);
    double yerr(int i);

    /*  ---------    Buttons and Scrollbars   ----------------------  */


  class CommandButton extends Button

    CommandButton(String name, int CommandCode);
    
  class ModeButton extends Button

    ModeButton(String name, int ModeCode);
    
  class BoldLabel extends Label;

    BoldLabel(String text);
    
  class PhysicsScrollbar extends Scrollbar;

    PhysicsScrollbar(double Value, double Minimum, double Maximum,
		                                         int CommandCode);    
    double getReading();

      /*  reprise:  complete list of abstract methods */

  abstract void resetArrays();
  abstract void resetAll();
  abstract void buildPicture();
  abstract void refreshPicture();
  abstract void buildControls();
  abstract void doAction(int Code);
  abstract void solve();
  abstract Color findColor(double A, int S);
  abstract void writeFieldValue(double Val, int mode);
  abstract void writeVectorValue(double Vx, double Vy, int mode);
  abstract void setArrays(int i, int j, int mode);
  abstract void plot();
}






















  
